<!-- <alexpounds:noList /> -->
<?php 

/* 
 * gfFunctions.php, part of The Grand Fandango 
 * http://www.alexpounds.com/code/grandfandango.php
 * 
 * Copyright 2004 Alex Pounds <alex@alexpounds.com>
 *
 * This file is part of The Grand Fandango.
 *
 * The Grand Fandango is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * The Grand Fandango is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * The Grand Fandango; if not, write to the Free Software Foundation, Inc., 59
 * Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

include_once($_SERVER["DOCUMENT_ROOT"] . "/userinfo.php");

// Constants. 
define("HOURINSECS", 60 * 60);
define("DAYINSECS", HOURINSECS * 24);
define("WEEKINSECS", DAYINSECS * 7);
define("MONTHINSECS", WEEKINSECS * 4);
define("YEARINSECS", DAYINSECS * 365);

    // Given a path, determine if it has a noList tag. 
    function hasNoListTag($path) {
        if (file_exists($path) && is_file($path) && is_readable($path)) { 
            // It's a file. Does it have an alexpounds:noList tag?
            $filehandle = fopen($path, "r");
            for ($i = 0; $i < 20; $i++) {
                $line = fgets($filehandle, 1024);
                if (preg_match("/<alexpounds:noList ?\/>/", $line)) {
                    fclose($filehandle);
                    return TRUE;
                }
            }
            fclose($filehandle);
            return FALSE;
        }
        return TRUE;
    }

    // Given a path to a directory, determine if it has an alexpounds.noList file.
    function hasNoListFile($path) {
        if (is_dir($path) && is_readable($path)) {
            if ($dh = opendir($path)) {
            while (false !== ($currentFile = readdir($dh))) {
                if ($currentFile == "alexpounds.noList" || $currentFile == "alexpounds.nolist") {
                    return TRUE;
                }
            }
            return FALSE;
        }
 
            
        }
        return TRUE;
    }

    // Given a path, determine if it has a new tag. 
    function hasNewTag($path) {
        if (file_exists($path) && is_file($path) && is_readable($path)) { 
            // It's a file. Does it have an alexpounds:new tag?
            $filehandle = fopen($path, "r");
            for ($i = 0; $i < 20; $i++) {
                $line = fgets($filehandle, 1024);
                if (preg_match("/<alexpounds:new ?\/>/", $line)) {
                    fclose($filehandle);
                    return TRUE;
                }
            }
            fclose($filehandle);
            return FALSE;
        }
        return FALSE;
    }
    // Given a path, determine its name. 
    function getPageName($path) {
        if (file_exists($path) && is_file($path) && is_readable($path)) {
            // It's a file. Does it have a menu tag? What's its name attribute, if so? 
            $filehandle = fopen($path, "r");
            if ($filehandle != null) {
                for ($i = 0; $i < 20; $i++) {
                    $line = fgets($filehandle, 1024);
                    if (preg_match("/<alexpounds:menu name=\"(.*)\" ?\/>/", $line, $matches)) {
                        fclose ($filehandle);
                        return $matches[1];
                    }
                    if (preg_match("/<title>(.*)<\/title>/", $line, $matches)) {
                        $title = $matches[1];
                    }
                }
                fclose ($filehandle);
                if (!empty($title)) {
                    return $title;
                } else {
                    return getCurrentFile($path, TRUE);
                }
            }
        }
        return FALSE;
    }

    // Given a path, output the file from that path - the index file if it's a directory. 
    function getCurrentFile ($currentPath, $isFullPath) {
        global $myExtension;
        if ($isFullPath) {
            $fullPath = $currentPath;
        } else {
            $fullPath = $_SERVER["DOCUMENT_ROOT"] . $currentPath;
        }
        if (is_dir($fullPath)) {
            return "index." . $myExtension; // We could change this to look in the dir and find out if there is another kind of index.
        } else if (is_file($fullPath)) {
            return basename($currentPath);
        } else {
            return FALSE;
        }
    }

    // Given a path, output the directory of that path.
    function getCurrentDir ($currentPath) {
        $fullPath = $_SERVER["DOCUMENT_ROOT"] . $currentPath;
        if (is_dir($fullPath)) {
            return $currentPath;
        } else if (is_file($fullPath)) {
            return dirname($currentPath);
        } else {
            return FALSE;
        }
    }

    // Given a path, give the parent directory of that path.
    function getParentDir ($currentPath) {
        $currentDir = getCurrentDir($currentPath);
        $explodedPath = explode("/", $currentDir);

        for ($i = 0; $i < count($explodedPath)-1; $i++) {
            if (!empty($explodedPath[$i])) {
                $parentDir .= "/" . $explodedPath[$i];
            }
        }
        if (!empty($parentDir)) {
            return $parentDir;
        } else {
            return "/";
        }
    }

    // Given a directory name, pretty-print the name of the directory. 
    function getDirName ($currentPath) {
        if (($currentDir = getCurrentDir($currentPath)) === FALSE) {
            $currentDir = $currentPath;
        }
        $explodedPath = explode("/", $currentDir);
        $target = $explodedPath[count($explodedPath)-1];

        for ($i = 0; $i < strlen($target); $i++) {
            if (preg_match("/[A-Z]/", $target[$i])) {
                $target = substr($target, 0, $i) . " " . substr($target, $i);
                $i++;
            }
        }
        $target = ucfirst($target);
        return $target;
    }


    function getDescription($path) {
        global $myUrl;
         if (file_exists($path) && is_file($path) && is_readable($path)) {
            // It's a file. Does it have a menu tag? What's its name attribute, if so? 
            $filehandle = fopen($path, "r");
            $readingParagraph = FALSE;
            while (!feof($filehandle)) {
                $line = fgets($filehandle, 1024);
                if (!$readingParagraph) {
                    if (preg_match("/<meta name=\"description\" content=\"(.*)\" ?\/>/", $line, $matches)) {
                        fclose ($filehandle);
                        return $matches[1];
                    } else if (preg_match("/<p>(.*)/", $line, $matches)) {
                        $paragraphText = $matches[1];
                        $readingParagraph = TRUE;
                    }
                } else {
                    if (preg_match("/(.*)<\/p>/", $line, $matches)) {
                        $paragraphText .= $matches[1];
                        fclose ($filehandle);
                        return "An article from " . $myUrl . " with no metatag, as of yet.";
                    } else {
                        $paragraphText .= $line;
                    }
                }
            }
            fclose ($filehandle);
            return "An article from " . $myUrl . ".";
        }
    }   

    // Read in the contents of the cached file specified, and return it as a string.  
    function getCacheContents($path) {
        if (file_exists($path) && is_file($path) && is_readable($path)) {
            $filehandle = fopen($path, "r");
            $contentsReached = FALSE;
            while (!feof($filehandle)) {
                $line = fgets($filehandle, 1024);
                if ($contentsReached) {
                    $contents .= $line;
                } else {
                    if (preg_match("/--- Cache contents begins below. Do not remove this line. ---/", $line)) {
                        $contentsReached = TRUE;
                    }
                }
            }
            fclose ($filehandle);
            return $contents;
            
        }
    }

    function setCacheContents($path, $contents) {
        // If the file exists, check it's writeable. Otherwise try and write it. 
        if ((file_exists($path) && is_writable($path)) || !file_exists($path)) {
            $filehandle = @fopen($path, "wb");
            if ($filehandle != null) {
                $output = "Timestamp: " . time() . "\n";
                $output .= "--- Cache contents begins below. Do not remove this line. ---\n";
                $output .= $contents;
                fwrite ($filehandle, $output);
                fclose ($filehandle);
            }
        }
    }
                

    function getLastUpdateTime($path) {
        if (file_exists($path) && is_file($path)) {
            // It's a file. Check the first 3 lines for a timestamp, and return it if found.
            $filehandle = fopen($path, "r");
            for ($i =0; $i < 3; $i++) {
                $line = fgets($filehandle, 1024);
                if (preg_match("/Timestamp: ?(.*)/", $line, $matches)) {
                    return $matches[1];
                }
            }
            fclose ($filehandle);
        }
        return 0;
    }

    // Given a timestamp, figure out how long ago it was modified and return the number for the suitable unit.
    function getNumber($time) {
        // Set time to the number of seconds since the update.
        $time = time() - $time;
        if ($time < 60) {
            return $time;
        } else if ($time < HOURINSECS) {
            return (int) ($time / 60); // return it in minutes.
        } else if ($time < DAYINSECS) {
            return (int) ($time / HOURINSECS); // return in hours.
        } else if ($time < WEEKINSECS) {
            return (int) ($time / DAYINSECS); // return in days.
        } else if ($time < MONTHINSECS) {
            return (int) ($time / WEEKINSECS); // return in weeks.
        } else if ($time < YEARINSECS) {
            return (int) ($time / MONTHINSECS); // return in lunar months.
        } else { 
            return (int) ($time / YEARINSECS); // return in years.
        }
    }

    // Given a timestamp, figure out how long ago it was modified and return the units of that. 
    function getUnits($time) {
        // Set time to the number of seconds since the update.
        $time = time() - $time;
        if ($time < 60) {
            return $abbreviate ? "s" : ($time > 1 ? " seconds ago" : " second ago");
        } else if ($time < HOURINSECS) {
            return $abbreviate ? "m" : ((int)($time / 60) > 1 ? " minutes ago" : " minute ago");
        } else if ($time < DAYINSECS) {
            return $abbreviate ? "h" : ((int)($time / HOURINSECS) > 1 ? " hours ago" : " hour ago");
        } else if ($time < WEEKINSECS) {
            return $abbreviate ? "d" : ((int)($time / DAYINSECS) > 1 ? " days ago" : " day ago");
        } else if ($time < MONTHINSECS) {
            return $abbreviate ? "w" : ((int)($time / WEEKINSECS)  > 1 ? " weeks ago" : " week ago");
        } else if ($time < YEARINSECS) {
            return $abbreviate ? "mo" : ((int)($time / MONTHINSECS)  > 1 ? " months ago" : " month ago"); 
        } else {
            return $abbreviate ? "y" : ((int)($time / YEARINSECS) > 1 ? " years ago" : " year ago");
        }
    }

    
    function generateWhatsNewRSSFeed($feedPath, $feedList) {
        global $myUrl, $mySiteName, $myDescription;
        // Generate RSS1.0 header.
        $feedData =  "<?xml version=\"1.0\"?>\n<rdf:RDF\n    xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n";
        $feedData .= "    xmlns=\"http://purl.org/rss/1.0/\"\n    xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n>\n";
        // Generate info about this channel.
        $feedData .= "<channel rdf:about=\"" . $myUrl . "whatsnew.rss\">\n    <title>What's New at " . $mySiteName . ".</title>\n";
        $feedData .= "    <link>" . $myUrl . "</link>\n";
        $feedData .= "    <description>What's new at " . $myDescription . ".</description>\n";
        
        $count = count($feedList) < 5 ? count($feedList) : 5;
        if ($count > 0) {
            // Generate contents list. 
            $feedData .= "    <items>\n        <rdf:Seq>\n";
            for ($i = 0; $i < $count; $i++) {
                $feedData .= sprintf("            <rdf:li resource=\"http://%s%s\" />\n", $_SERVER["SERVER_NAME"], $feedList[$i][0]);
            }
            $feedData .= "        </rdf:Seq>\n    </items>\n</channel>\n\n";

            // Generate items. 
            for ($i = 0; $i < $count; $i++) {
                $feedData .= sprintf("<item rdf:about=\"http://%s%s\">\n", $_SERVER["SERVER_NAME"], $feedList[$i][0]);
                $feedData .= sprintf("    <title>%s</title>\n", $feedList[$i][1]);
                $feedData .= sprintf("    <link>http://%s%s</link>\n", $_SERVER["SERVER_NAME"], $feedList[$i][0]);
                $feedData .= sprintf("    <dc:date>%s</dc:date>\n", strftime("%Y-%m-%d", $feedList[$i][2]));
                $feedData .= sprintf("    <description>%s</description>\n", $feedList[$i][3]);
                $feedData .= sprintf("</item>\n");
            }
            $feedData .= sprintf("</rdf:RDF>\n");
        } else {
            // Generate one item in the contents list, and it's a blank item.
            $feedData .= "    <items>\n        <rdf:Seq>\n";
            $feedData .= "            <rdf:li resource=\"" . $myUrl . "\" />\n" ;
            $feedData .= "        </rdf:Seq>\n    </items>\n</channel>\n\n";
            $feedData .= "<item rdf:about=\"" . $myUrl . "\">\n";
            $feedData .= "    <title>Nothing New</title>\n";
            $feedData .= "    <link>" . $myUrl . "</link>\n";
            $feedData .= "    <description>There's nothing new at " . $mySiteName . ".</description>\n";
            $feedData .= "</item>\n";
            $feedData .= "</rdf:RDF>\n";
        }
        
        // OK. Now, read in the existing feed, if it exists.
        if (file_exists($feedPath) && is_file($feedPath) && is_readable($feedPath)) {
            $filehandle = fopen($feedPath, "r");
            $fileContents =  fread($filehandle, filesize($feedPath));
            fclose($filehandle);

            if ($feedData == $fileContents) {
                return TRUE;
            }
        }

        if ((file_exists($feedPath) && is_file($feedPath) && is_writable($feedPath)) || !file_exists($feedPath)) {
            $filehandle = @fopen($feedPath, "wb");
            if ($filehandle != null) {
                fwrite($filehandle, $feedData);
                fclose($filehandle);
                return TRUE;
            }
        }
        return FALSE; // No RSS feed exists.
    }
            
    function generateWhatsUpdatedRSSFeed($feedPath, $feedList) {
        global $myUrl, $mySiteName, $myDescription;
        // Generate RSS1.0 header.
        $feedData =  "<?xml version=\"1.0\"?>\n<rdf:RDF\n    xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n";
        $feedData .= "    xmlns=\"http://purl.org/rss/1.0/\"\n    xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n>\n";
        // Generate info about this channel.
        $feedData .= "<channel rdf:about=\"" . $myUrl . "whatsupdated.rss\">\n";
        $feedData .= "    <title>What's Updated at " . $mySiteName . "</title>\n";
        $feedData .= "    <link>" . $myUrl . "</link>\n";
        $feedData .= "    <description>What's updated at " . $myDescription . ".</description>\n";
        
        $count = count($feedList) < 5 ? count($feedList) : 5;
        if ($count > 0) {
            // Generate contents list. 
            $feedData .= "    <items>\n        <rdf:Seq>\n";
            for ($i = 0; $i < $count; $i++) {
                $feedData .= sprintf("            <rdf:li resource=\"http://%s%s\" />\n", $_SERVER["SERVER_NAME"], $feedList[$i][0]);
            }
            $feedData .= "        </rdf:Seq>\n    </items>\n</channel>\n\n";

            // Generate items. 
            for ($i = 0; $i < $count; $i++) {
                $feedData .= sprintf("<item rdf:about=\"http://%s%s\">\n", $_SERVER["SERVER_NAME"], $feedList[$i][0]);
                $feedData .= sprintf("    <title>%s</title>\n", $feedList[$i][1]);
                $feedData .= sprintf("    <link>http://%s%s</link>\n", $_SERVER["SERVER_NAME"], $feedList[$i][0]);
                $feedData .= sprintf("    <dc:date>%s</dc:date>\n", strftime("%Y-%m-%d", $feedList[$i][2]));
                $feedData .= sprintf("    <description>%s</description>\n", $feedList[$i][3]);
                $feedData .= sprintf("</item>\n");
            }
            $feedData .= sprintf("</rdf:RDF>\n");
        } else {
            // Generate one item in the contents list, and it's a blank item.
            $feedData .= "    <items>\n        <rdf:Seq>\n";
            $feedData .= "            <rdf:li resource=\"" . $myUrl . "\" />\n" ;
            $feedData .= "        </rdf:Seq>\n    </items>\n</channel>\n\n";
            $feedData .= "<item rdf:about=\"" . $myUrl . "\">\n";
            $feedData .= "    <title>Nothing New</title>\n";
            $feedData .= "    <link>" . $myUrl . "</link>\n";
            $feedData .= "    <description>There's nothing new at " . $mySiteName . ".</description>\n";
            $feedData .= "</item>\n";
            $feedData .= "</rdf:RDF>\n";
        }

        // OK. Now, read in the existing feed, if it exists.
        if (file_exists($feedPath) && is_file($feedPath) && is_readable($feedPath)) {
            $filehandle = fopen($feedPath, "r");
            $fileContents =  fread($filehandle, filesize($feedPath));
            fclose($filehandle);

            if ($feedData == $fileContents) {
                return TRUE;
            }
        }

        if ((file_exists($feedPath) && is_file($feedPath) && is_writable($feedPath)) || !file_exists($feedPath)) {
            $filehandle = @fopen($feedPath, "wb");
            if ($filehandle != null) {
                fwrite($filehandle, $feedData);
                fclose($filehandle);
                return TRUE;
            }
        }
        return FALSE; // If we get here, we haven't got an RSS Feed. 
    }
?>
