<!-- <alexpounds:noList /> -->

<?

include_once($_SERVER["DOCUMENT_ROOT"] . "/gfFunctions.php");
include_once($_SERVER["DOCUMENT_ROOT"] . "/userinfo.php");

function buildInnerNav($currentPath) {
    global $myExtension;
    $file = getCurrentFile($currentPath, FALSE);
    $dir = getCurrentDir($currentPath);
    $pathDir = $_SERVER["DOCUMENT_ROOT"] . $dir;
    $parentPath = getParentDir($currentPath);

    if ($dir != "/") {
        buildOuterNav($parentPath, $currentPath, TRUE, 0);
    }
    
    if ($dir !== FALSE && $file !== FALSE) {
        if ($dh = opendir($pathDir)) { // Open directory.
            echo "<ul>\n";
            // If we're in the root, add a "Home" link as we discard the index file in the loop below.
            if ($dir == "/") { 
                if ($file == "index." . $myExtension) {
                    echo "<li><b>Home</b></li>\n";
                } else {
                    echo "<li><a href=\"/\">Home</a></li>\n";
                }
            }
            while (false !== ($currentFile = readdir($dh))) { // Iterate over files in directory one by one.
                $fullPath = $pathDir . "/" . $currentFile;
                // If it's not a dotfile, ., .., the index, AND if it's a PHP file, an HTML file, or a directory, AND it's a file without
                // an <alexpounds:noList /> tag or it's a directory without an alexpounds.noList file, examine it.
                if ((!preg_match("%^\.%", $currentFile) && $currentFile != ".." && !preg_match("%index\.%", $currentFile)) &&
                    (preg_match("%\.php$%", $currentFile) || preg_match("%\.html?$%", $currentFile) || is_dir($fullPath)) &&
                    ((is_file($fullPath) && !hasNoListTag($fullPath)) || (is_dir($fullPath) && !hasNoListFile($fullPath)))) {
                    if ($dir != "/") {
                        $docRootPath = $dir . "/" . $currentFile;
                    } else {
                        $docRootPath = "/" . $currentFile;
                    }
                    
                    //If the current file under consideration is the same as the current file being viewed by the user, output bold text.
                    if ($currentFile == $file) {
                        $currentName = getPageName($fullPath);
                        echo "<li><b>" . $currentName . "</b></li>\n";
                    } else if (is_dir($fullPath)) {
                        echo "<li><a href=\"" . $docRootPath. "\">" . getDirName($docRootPath) . "</a></li>\n";
                    }  else {
                        $currentName = getPageName($fullPath);
                        echo "<li><a href=\"" . $docRootPath . "\">" . $currentName . "</a></li>\n";
                    }
                }
            }
            echo "</ul>\n";
        }
    }
    if ($dir != "/") {
        buildOuterNav($parentPath, $currentPath, FALSE, 0);
    }
}

function buildOuterNav($buildPath, $currentPath, $before, $level) {
    global $myExtension;
    $file = getCurrentFile($currentPath, FALSE);
    $currentParentPath = getCurrentDir($currentPath);
    $parentPath = getParentDir($buildPath);
    $pathDir = $_SERVER["DOCUMENT_ROOT"] . $buildPath;
    
    // We use before to toggle the output, so it only builds the start of the list if being called before the existing one, 
    // And only builds the end of the list if being called after the existing one.
    if ($before) {
        $output = TRUE;
    } else {
        $output = FALSE;
    } 

    // If we're not building the root, and are being called before the list, build the list for the directory above this one.
    if ($buildPath != "/" && $output) {
        buildOuterNav($parentPath, $buildPath, TRUE, $level+1);
    }

    if ($file !== FALSE) {
         if ($dh = opendir($pathDir)) { // Open the directory. 
             if ($output) { // If it's the start, then output an opening list tag. 
                 echo "<ul>\n";
                 if ($buildPath == "/") {
                     echo "<li><a href=\"/\">Home</a></li>\n";
                 }
             }
             while (false !== ($currentFile = readdir($dh))) { // Iterate over each entry in the directory. 
                 $fullPath = $pathDir . "/" . $currentFile;
                 // If it's not a dotfile, ., .., and not an index file, AND it's a PHP file, an HTML file, or a directory, 
                 // AND it's a file with no <alexpounds:noList /> tag or it's a directory with no alexpounds.noList file, 
                 // consider it. 
                 if ((!preg_match("%^\.%", $currentFile) && $currentFile != ".." && !preg_match("%index\.%", $currentFile)) &&
                     (preg_match("%\.php$%", $currentFile) || preg_match("%\.html?$%", $currentFile) || is_dir($fullPath)) && 
                     ((is_file($fullPath) && !hasNoListTag($fullPath)) || (is_dir($fullPath) && !hasNoListFile($fullPath)))) {
                     
                     // Build a path from the docroot. 
                     if ($buildPath != "/") {
                         $docRootPath = $buildPath . "/" . $currentFile;
                     } else {
                         $docRootPath = "/" . $currentFile;
                     }

                     // If it's an index file, and we're currently looking at its containing directory, we want a no-link bold output.
                     if ($file == "index." . $myExtension && $docRootPath == $currentParentPath && $level == 0) {
                         if ($output) {
                             echo "<li><b>" . getDirName($docRootPath) . "</b>";
                         }
                     // Otherwise, if it's a directory, output a link to it.
                     } else if (is_dir($fullPath)) {
                         if ($output) {
                             echo "<li><a href=\"" . $docRootPath . "\">" . getDirName($docRootPath) . "</a>";
                         }
                     // Otherwise, output a link to the file.
                     } else {
                         if ($output) {
                             $currentName = getPageName($fullPath);
                             echo "<li><a href=\"" . $docRootPath . "\">" . $currentName . "</a>";
                         }
                     }
                     // If the current entry is the same as the place on the filesystem that the parent function is listing, 
                     // toggle the output. 
                     if ($docRootPath == $currentParentPath) {
                         $output = !$output;
                     }
                     if ($output) {
                         echo "</li>\n";
                     }
                 }
             }
             if ($output) {
                 echo "</ul>\n";
             }
         }
    }
    if ($buildPath != "/" && $output) {
        buildOuterNav($parentPath, $buildPath, FALSE, $level+1);
    }
}
 
echo "<h3>Navigation</h3>\n";
buildInnerNav($_SERVER["PHP_SELF"]);

?>
