<!-- <alexpounds:noList /> -->
<?

/* 
 * sitemap.php, part of The Grand Fandango 
 * http://www.alexpounds.com/code/grandfandango.php
 * 
 * Copyright 2006 Alex Pounds <alex@alexpounds.com>
 *
 * This file is part of The Grand Fandango.
 *
 * The Grand Fandango is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * The Grand Fandango is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * The Grand Fandango; if not, write to the Free Software Foundation, Inc., 59
 * Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

include_once($_SERVER["DOCUMENT_ROOT"] . "/gfFunctions.php");
include_once($_SERVER["DOCUMENT_ROOT"] . "/userinfo.php");

// Useful definitions. 
$cacheFile = "/.sitemapcache";
define ("INTERVAL", 3600);
// Do not edit below this line. 


$cacheFile = $_SERVER["DOCUMENT_ROOT"] . $cacheFile;
if (is_file($cacheFile)) { 
    $lastUpdate = getLastUpdateTime($cacheFile); 
    if ($lastUpdate + INTERVAL >= time()) {
        // Use the cached version.
        print (getCacheContents($cacheFile));
        exit;
    }
}
// Rebuild the sitemap. 
$sitemap = "<h2>Site Map</h2>\n";
$sitemap .= buildSiteMap("/");
print ($sitemap);
// Cache new sitemap.
setCacheContents($cacheFile, $sitemap);


function buildSiteMap($dir) {
    global $myExtension;
    $pathDir = $_SERVER["DOCUMENT_ROOT"] . $dir;
    
    if ($dh = opendir($pathDir)) { // Open directory.
        $sitemap .= "<ul>\n";
        // If we're in the root, add a "Home" link as we discard the index file in the loop below.
        if ($dir == "/") { 
            $sitemap .= "<li><a href=\"/\">Home</a></li>\n";
        }
        while (false !== ($currentFile = readdir($dh))) { // Iterate over files in directory one by one.
            $fullPath = "$pathDir/$currentFile";
            // If it's not a dotfile, ., .., the index, AND if it's a PHP file, an HTML file, or a directory, AND it's a file without
            // an <alexpounds:noList /> tag or it's a directory without an alexpounds.noList file, examine it.
            if ((!preg_match("%^\.%", $currentFile) && $currentFile != ".." && !preg_match("%index\.%", $currentFile)) &&
                (preg_match("%\.php$%", $currentFile) || preg_match("%\.html?$%", $currentFile) || is_dir($fullPath)) &&
                ((is_file($fullPath) && !hasNoListTag($fullPath)) || (is_dir($fullPath) && !hasNoListFile($fullPath)))) {
                
                if ($dir != "/") { 
                    $docRootPath = "$dir/$currentFile";
                } else {
                    $docRootPath = "/$currentFile";
                }
                
                if (is_dir($fullPath)) {
                    $sitemap .= "<li><a href=\"$docRootPath\">" . getDirName($docRootPath) . "</a>\n";
                    $sitemap .= buildSiteMap($docRootPath);
                    $sitemap .= "</li>\n";
                }  else {
                    $currentName = getPageName($fullPath);
                    $sitemap .= "<li><a href=\"$docRootPath\">$currentName</a></li>\n";
                }
            }
        }
        $sitemap .= "</ul>\n";
    }
    return $sitemap;
}


?>
