<!-- <alexpounds:noList /> -->
<?php

/* 
 * whatsupdated.php, part of The Grand Fandango 
 * http://www.alexpounds.com/code/grandfandango.php
 * 
 * Copyright 2004-2006 Alex Pounds <alex@alexpounds.com>
 *
 * This file is part of The Grand Fandango.
 *
 * The Grand Fandango is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * The Grand Fandango is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * The Grand Fandango; if not, write to the Free Software Foundation, Inc., 59
 * Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

include_once($_SERVER["DOCUMENT_ROOT"] . "/gfFunctions.php");

// Useful definitions. 
$cacheFile = "/.whatsupdatedcache";
$feedFile = "/whatsupdated.rss";
define ("INTERVAL", 3600);
// Do not edit below this line. 

$cacheFile = $_SERVER["DOCUMENT_ROOT"] . $cacheFile;
$bareFeedFile = $feedFile;
$feedFile = $_SERVER["DOCUMENT_ROOT"] . $feedFile;
if (is_file($cacheFile)) { 
    $lastUpdate = getLastUpdateTime($cacheFile);
    if ($lastUpdate + INTERVAL >= time()) {
        // Use the cached version.
        $whatsUpdatedText = getCacheContents($cacheFile);
        print ($whatsUpdatedText);
    }
}

if (empty($whatsUpdatedText)) {
    // Cache is out of date or doesn't exist; build new list and write out cache.
    $uList = getUpdateDirContents("");
    //  Sort the list by modified date. 
    if (!empty($uList)) {
        foreach ($uList as $key => $row) {
            $dateTime[$key] = $row[2];
        }
        array_multisort($dateTime, SORT_DESC, $uList);
    }
    $rssGenerated = generateWhatsNewRSSFeed($feedFile, $uList);
    
    $whatsUpdatedText = "<h3>What's updated</h3>\n" . "<ul>\n";
    if (count($uList) > 0) {
        for ($i = 0; $i < (count($uList) < 5 ? count($uList) : 5); $i++) {
            $whatsUpdatedText .= sprintf("<li><a href=\"%s\">%s</a>", $uList[$i][0], $uList[$i][1]);
            if ($whatsUpdatedExtendedDetails) { 
                $whatsUpdatedText .=
                    sprintf(" <span class=\"extendedinfo\">(%d%s)</span>", getNumber($uList[$i][2]), getUnits($uList[$i][2]));
            }
            $whatsUpdatedText .= "</li>\n";
        }
    } else {
        $whatsUpdatedText .= "<li>Nothing is updated.</li>\n";
    }
    $whatsUpdatedText .= "</ul>\n";
    if ($rssGenerated) {
        $whatsUpdatedText .= "<div class=\"rssbutton\"><a href=\"$bareFeedFile\"><img src=\"/rssbutton.gif\" alt=\"RSS Feed for what's updated\" /></a></div>\n";
    }

    print $whatsUpdatedText;
    setCacheContents($cacheFile, $whatsUpdatedText);
} 



function getUpdateDirContents($pathFromDocRoot) {
    $files = array();
    if ($dh = @opendir($_SERVER["DOCUMENT_ROOT"] . $pathFromDocRoot)) {
        while (false !== ($filename = readdir($dh))) {
            $longpath = $_SERVER["DOCUMENT_ROOT"] . $pathFromDocRoot . "/" . $filename;
            if (($filename != "." && $filename != "..") && 
               (preg_match("%\.php$%", $filename) || preg_match("%\.html?$%", $filename) || is_dir($longpath))) {
                if (is_dir($longpath)) {
                    $files = array_merge($files, getUpdateDirContents($pathFromDocRoot . "/" . $filename));
                } else if (is_file($longpath)) {
                    if (!hasNoListTag($longpath) && !hasNewTag($longpath)) {
                        $time = @stat($longpath);
                        $files[] = array($pathFromDocRoot . "/" . $filename, getPageName($longpath), $time[9], chop(getDescription($longpath)));
                    }
                }
            }
        }
        closedir($dh);
    }
    return $files;
}

?>
